package net.javajigi.audit;

import java.util.Date;


import org.apache.commons.lang.builder.EqualsBuilder;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

public class AuditObject {
	private Long id;
	private String who;
	private Date whenn;
	private String resource;
	private String action;

	private AuditDao auditDao;

	public AuditObject() {
		this(null, null);
	}

	public AuditObject(String resource, String action) {
		initWho();
		initWhen();
		this.resource = resource;
		this.action = action;
	}

	public void setAuditDao(AuditDao auditDao) {
		this.auditDao = auditDao;
	}

	private void initWho() {
		this.who = (String) System.getProperties().get("user.name");
	}

	private void initWhen() {
		this.whenn = new Date();
	}

	public void setId(Long i) {
		id = i;
	}

	public Long getId() {
		return id;
	}

	public void setWho(String who) {
		this.who = who;
	}

	public String getWho() {
		return who;
	}

	public void setWhenn(Date when) {
		this.whenn = when;
	}

	public Date getWhenn() {
		return whenn;
	}

	public void setResource(String resource) {
		this.resource = resource;
	}

	public String getResource() {
		return resource;
	}

	public void setAction(String action) {
		this.action = action;
	}

	public String getAction() {
		return action;
	}

	@Transactional(propagation = Propagation.REQUIRED)
	public void create(String resource, String action) {
		setResource(resource);
		setAction(action);

		auditDao.log(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof AuditObject == false) {
			return false;
		}
		if (this == obj) {
			return true;
		}
		AuditObject audit = (AuditObject) obj;
		return new EqualsBuilder().append(getId(), audit.getId()).append(getResource(), audit.getResource()).append(
				getAction(), audit.getAction()).isEquals();
	}
}
