package net.javajigi.user.web.coc;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.user.model.User;

import org.springframework.web.servlet.view.AbstractView;

public class XMLUserView extends AbstractView {
	@SuppressWarnings("unchecked")
	@Override
	protected void renderMergedOutputModel(Map model, HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		List<User> users = (List<User>)model.get("users");
		
		StringBuffer sb = new StringBuffer();
		sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		
		sb.append("<users>");
		for (Iterator iterator = users.iterator(); iterator.hasNext();) {
			User user = (User) iterator.next();
			
			sb.append("<user>");
			sb.append("<id>" + user.getUserId() + "</id>");
			sb.append("<name>" + user.getName() + "</name>");
			sb.append("<email>" + user.getEmail() + "</email>");
			sb.append("</user>");
		}
		sb.append("</users>");
		
		response.setContentType("text/xml;charset=utf-8");
		response.setHeader("Cache-Control", "no-cache");
		
		response.getWriter().write(sb.toString());
	}
}
